package com.ozs.web.controller.accountmanagment;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ozs.common.core.controller.BaseController;
import com.ozs.common.core.domain.AjaxResult;
import com.ozs.common.utils.AppendUtils;
import com.ozs.service.entity.BaseCameraManagement;
import com.ozs.service.entity.BaseRailwayManagement;
import com.ozs.service.entity.MsgAlarm;
import com.ozs.service.entity.MsgAlarmFrequency;
import com.ozs.service.entity.vo.MsgAlarmResp;
import com.ozs.service.entity.vo.MsgAlarmVo;
import com.ozs.service.service.BaseCameraManagementService;
import com.ozs.service.service.BaseRailwayManagementService;
import com.ozs.service.service.MsgAlarmFrequencyService;
import com.ozs.service.service.MsgAlarmService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 * 报警信息表 前端控制器
 * </p>
 *
 * @author ozs
 * @since 2023-02-22
 */
@RestController
@RequestMapping("/service/msgAlarm")
public class MsgAlarmController extends BaseController {
    @Resource
    MsgAlarmService msgAlarmService;
    @Resource
    MsgAlarmFrequencyService msgAlarmFrequencyService;
    @Autowired
    BaseCameraManagementService baseCameraManagementService;
    @Autowired
    BaseRailwayManagementService baseRailwayManagementService;

    /**
     * 测试消息推送
     */
    @PostMapping("/push")
    @ApiOperation(value = "预报警信息分页")
    public AjaxResult insertDate(String[] args) {
        // 模拟需要推送的用户群
        ArrayList<String> ids = new ArrayList<>();
        ids.add("001");
        ids.add("002");
        ids.add("003");
        ids.add("004");
        ids.add("005");
//
//        WebSocketService webSocketService = new WebSocketService();
//        webSocketService.sendMsgToUsers(ids);
        return AjaxResult.success("推送成功");
    }

    /**
     * 报警信息分页
     *
     * @param msgAlarmVo
     * @return
     */
    @ApiOperation(value = "报警信息分页")
    @PostMapping("/list")
    public AjaxResult selectMsgAlarm(@RequestBody MsgAlarmVo msgAlarmVo) {
        List<BaseCameraManagement> baseCameraManagementList=new ArrayList<>();
        LambdaQueryWrapper<BaseCameraManagement> wrapper = new LambdaQueryWrapper<BaseCameraManagement>();
        if (!ObjectUtils.isEmpty(msgAlarmVo.getRailwayCode())) {
            wrapper.eq(BaseCameraManagement::getRailwayCode, msgAlarmVo.getRailwayCode());
        }
        if (!ObjectUtils.isEmpty(msgAlarmVo.getBeginMile())) {
            wrapper.ge(BaseCameraManagement::getBeginMile, msgAlarmVo.getBeginMile());
        }
        if (!ObjectUtils.isEmpty(msgAlarmVo.getEndMile())) {
            wrapper.le(BaseCameraManagement::getEndMile, msgAlarmVo.getEndMile());
        }
        if (!ObjectUtils.isEmpty(msgAlarmVo.getRailwayCode())||!ObjectUtils.isEmpty(msgAlarmVo.getBeginMile())||!ObjectUtils.isEmpty(msgAlarmVo.getEndMile())) {
            baseCameraManagementList = baseCameraManagementService.list(wrapper);
        }
        LambdaQueryWrapper<MsgAlarm> lw = new LambdaQueryWrapper<MsgAlarm>();
        if (!ObjectUtils.isEmpty(msgAlarmVo.getLineDir())) {
            lw.eq(MsgAlarm::getLineDir, msgAlarmVo.getLineDir());
        }
        if (baseCameraManagementList.size()>0) {
            List<String> collect = baseCameraManagementList.stream().map(BaseCameraManagement::getCameraCode).collect(Collectors.toList());
            lw.in(MsgAlarm::getCameraCode, collect);
        }
        if (!ObjectUtils.isEmpty(msgAlarmVo.getAlarmType())) {
            lw.eq(MsgAlarm::getAlarmType, msgAlarmVo.getAlarmType());
        }
        if (!ObjectUtils.isEmpty(msgAlarmVo.getAlarmMile())) {
            lw.eq(MsgAlarm::getAlarmMile, msgAlarmVo.getAlarmMile());
        }
        if (!ObjectUtils.isEmpty(msgAlarmVo.getBeginAlarmTime())) {
            lw.ge(MsgAlarm::getAlarmTime, msgAlarmVo.getBeginAlarmTime());
        }
        if (!ObjectUtils.isEmpty(msgAlarmVo.getEndAlarmTime())) {
            lw.le(MsgAlarm::getAlarmTime, msgAlarmVo.getEndAlarmTime());
        }
        if (!ObjectUtils.isEmpty(msgAlarmVo.getIsLock())) {
            lw.eq(MsgAlarm::getIsLock, msgAlarmVo.getIsLock());
        }
        IPage<MsgAlarm> page = msgAlarmService.page(new Page<>(msgAlarmVo.getPageNum(), msgAlarmVo.getPageSize()), lw);
        if(!ObjectUtils.isEmpty(page) && !ObjectUtils.isEmpty(page.getRecords())){
            List<MsgAlarm> dto1 = page.getRecords().stream().map(o -> {
                LambdaQueryWrapper<BaseCameraManagement> cameraManagementLambdaQueryWrapper = new LambdaQueryWrapper<BaseCameraManagement>();
                if (!ObjectUtils.isEmpty(o.getCameraCode())) {
                    cameraManagementLambdaQueryWrapper.eq(BaseCameraManagement::getCameraCode, o.getCameraCode());
                }
                BaseCameraManagement cameraManagement = baseCameraManagementService.getOne(cameraManagementLambdaQueryWrapper);
                LambdaQueryWrapper<BaseRailwayManagement> queryWrapper = new LambdaQueryWrapper<BaseRailwayManagement>();
                if (!ObjectUtils.isEmpty(cameraManagement.getRailwayCode())) {
                    queryWrapper.eq(BaseRailwayManagement::getRailwayCode, cameraManagement.getRailwayCode());
                }
                BaseRailwayManagement baseRailwayManagement = baseRailwayManagementService.getOne(queryWrapper);

                o.setRailwayName(baseRailwayManagement.getRailwayName());
                String mils = AppendUtils.stringAppend(cameraManagement.getInstallMile());
                o.setAlarmMiles(mils);
                String end = AppendUtils.stringAppend(cameraManagement.getEndMile());
                o.setEndMile(end);
                String begin = AppendUtils.stringAppend(cameraManagement.getBeginMile());
                o.setBeginMile(begin);
                o.setAlarmCount((int) msgAlarmFrequencyService.count()+1);
                return o;
            }).collect(Collectors.toList());
            page.setRecords(dto1);
        }
        return AjaxResult.success(page);
    }

    @GetMapping(value = "/{id}")
    @ApiOperation("根据报警信息ID获取详细信息")
    public AjaxResult getInfo(@PathVariable Long id) {
        MsgAlarm msgAlarm = msgAlarmService.getById(id);
        LambdaQueryWrapper<BaseCameraManagement> lw = new LambdaQueryWrapper<BaseCameraManagement>();
        if (!ObjectUtils.isEmpty(msgAlarm.getCameraCode())) {
            lw.eq(BaseCameraManagement::getCameraCode, msgAlarm.getCameraCode());
        }
        BaseCameraManagement baseCameraManagement = baseCameraManagementService.getOne(lw);
        LambdaQueryWrapper<BaseRailwayManagement> wrapper = new LambdaQueryWrapper<BaseRailwayManagement>();
        if (!ObjectUtils.isEmpty(baseCameraManagement.getRailwayCode())) {
            wrapper.eq(BaseRailwayManagement::getRailwayCode, baseCameraManagement.getRailwayCode());
        }
        BaseRailwayManagement baseRailwayManagement = baseRailwayManagementService.getOne(wrapper);
        MsgAlarmResp msgAlarmResp = new MsgAlarmResp();
        BeanUtils.copyProperties(msgAlarm, msgAlarmResp);
        msgAlarmResp.setRailwayName(baseRailwayManagement.getRailwayName());
        msgAlarmResp.setDeptId(baseCameraManagement.getDeptId());
        String begin = AppendUtils.stringAppend(baseCameraManagement.getBeginMile());
        String end = AppendUtils.stringAppend(baseCameraManagement.getEndMile());
        String endMile=begin+"-"+end;
        msgAlarmResp.setBeginMile(endMile);
        String mile = AppendUtils.stringAppend(baseCameraManagement.getInstallMile());
        msgAlarmResp.setAlarmMile(mile);
        msgAlarmResp.setInstallLongitude(baseCameraManagement.getInstallLongitude()+","+baseCameraManagement.getInstallLatitude());
        return AjaxResult.success(msgAlarmResp);
    }


    @PutMapping(value = "/{id}")
    @ApiOperation("根据报警信息ID解除报警")
    public AjaxResult updateIsLock(@PathVariable Long id) {
        MsgAlarm msgAlarm = msgAlarmService.getById(id);
        msgAlarm.setIsLock(1);
        msgAlarm.setUpdateBy(getUserId());
        msgAlarm.setReleasedBy(getUserId());
        msgAlarm.setReleasedTime(new Date());
        return AjaxResult.success(msgAlarmService.updateById(msgAlarm));
    }

    @GetMapping(value = "/alarmHistoricalAlarm/{alarmId}")
    @ApiOperation("报警消息详情历史报警次数信息")
    public AjaxResult alarmHistoricalAlarm(@PathVariable Long alarmId) {
        QueryWrapper<MsgAlarmFrequency> wrapper = new QueryWrapper<>();
        wrapper.eq("alarm_id", alarmId);
        wrapper.orderByDesc("alarm_time");
        List<MsgAlarmFrequency> list = msgAlarmFrequencyService.list(wrapper);
        return AjaxResult.success(list);
    }

    @GetMapping(value = "/videoHistoricalAlarm/{alarmId}")
    @ApiOperation("视频服务历史报警信息")
    public AjaxResult videoHistoricalAlarm(@PathVariable Long alarmId) {
        QueryWrapper<MsgAlarm> wrapper = new QueryWrapper<>();
        wrapper.eq("alarm_id", alarmId);
        wrapper.orderByDesc("alarm_time");
        List<MsgAlarm> list = msgAlarmService.list(wrapper);
        return AjaxResult.success(list);
    }
}

